Index: /trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- /trunk/sources/HeuristicLab 3.3.sln	(revision 2833)
+++ /trunk/sources/HeuristicLab 3.3.sln	(revision 2834)
@@ -151,4 +151,8 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.SGA-3.3.Tests", "HeuristicLab.SGA\3.3\Tests\HeuristicLab.SGA-3.3.Tests.csproj", "{F42F3576-7233-4B28-90F7-36AE15F30F92}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimization-3.3", "HeuristicLab.Optimization\3.3\HeuristicLab.Optimization-3.3.csproj", "{14AB8D24-25BC-400C-A846-4627AA945192}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Optimization.Views-3.3", "HeuristicLab.Optimization.Views\3.3\HeuristicLab.Optimization.Views-3.3.csproj", "{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}"
 EndProject
 Global
@@ -675,4 +679,20 @@
 		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x64.ActiveCfg = Release|Any CPU
 		{F42F3576-7233-4B28-90F7-36AE15F30F92}.Release|x86.ActiveCfg = Release|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|Any CPU.Build.0 = Release|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x64.ActiveCfg = Release|Any CPU
+		{14AB8D24-25BC-400C-A846-4627AA945192}.Release|x86.ActiveCfg = Release|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|Any CPU.Build.0 = Release|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x64.ActiveCfg = Release|Any CPU
+		{662B4B15-8F4D-4AE5-B3EB-D91C215F5AF2}.Release|x86.ActiveCfg = Release|Any CPU
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: /trunk/sources/HeuristicLab 3.3/Files.txt
===================================================================
--- /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2833)
+++ /trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2834)
@@ -23,4 +23,6 @@
 HeuristicLab.Operators.Views.GraphVisualization\3.3:HeuristicLab.Operators.Views.GraphVisualization-3.3.dll 
 HeuristicLab.Operators.Programmable\3.3:HeuristicLab.Operators.Programmable-3.3.dll 
+HeuristicLab.Optimization\3.3:HeuristicLab.Optimization-3.3.dll 
+HeuristicLab.Optimization.Views\3.3:HeuristicLab.Optimization.Views-3.3.dll 
 HeuristicLab.Optimizer\3.3:HeuristicLab.Optimizer-3.3.dll 
 HeuristicLab.Parameters\3.3:HeuristicLab.Parameters-3.3.dll 
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.Designer.cs	(revision 2834)
@@ -54,7 +54,4 @@
       this.startButton = new System.Windows.Forms.Button();
       this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.newProblemButton = new System.Windows.Forms.Button();
-      this.openProblemButton = new System.Windows.Forms.Button();
-      this.saveProblemButton = new System.Windows.Forms.Button();
       this.newOperatorGraphButton = new System.Windows.Forms.Button();
       this.openOperatorGraphButton = new System.Windows.Forms.Button();
@@ -64,6 +61,4 @@
       this.operatorGraphViewHost = new HeuristicLab.Core.Views.ViewHost();
       this.globalScopeTabPage = new System.Windows.Forms.TabPage();
-      this.problemTabPage = new System.Windows.Forms.TabPage();
-      this.problemViewHost = new HeuristicLab.Core.Views.ViewHost();
       this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
       this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
@@ -71,5 +66,4 @@
       this.operatorGraphTabPage.SuspendLayout();
       this.globalScopeTabPage.SuspendLayout();
-      this.problemTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -142,37 +136,4 @@
       this.startButton.Click += new System.EventHandler(this.startButton_Click);
       // 
-      // newProblemButton
-      // 
-      this.newProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.NewDocument;
-      this.newProblemButton.Location = new System.Drawing.Point(6, 6);
-      this.newProblemButton.Name = "newProblemButton";
-      this.newProblemButton.Size = new System.Drawing.Size(24, 24);
-      this.newProblemButton.TabIndex = 0;
-      this.toolTip.SetToolTip(this.newProblemButton, "Create New Problem");
-      this.newProblemButton.UseVisualStyleBackColor = true;
-      this.newProblemButton.Click += new System.EventHandler(this.newProblemButton_Click);
-      // 
-      // openProblemButton
-      // 
-      this.openProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Open;
-      this.openProblemButton.Location = new System.Drawing.Point(36, 6);
-      this.openProblemButton.Name = "openProblemButton";
-      this.openProblemButton.Size = new System.Drawing.Size(24, 24);
-      this.openProblemButton.TabIndex = 1;
-      this.toolTip.SetToolTip(this.openProblemButton, "Open Problem");
-      this.openProblemButton.UseVisualStyleBackColor = true;
-      this.openProblemButton.Click += new System.EventHandler(this.openProblemButton_Click);
-      // 
-      // saveProblemButton
-      // 
-      this.saveProblemButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Save;
-      this.saveProblemButton.Location = new System.Drawing.Point(66, 6);
-      this.saveProblemButton.Name = "saveProblemButton";
-      this.saveProblemButton.Size = new System.Drawing.Size(24, 24);
-      this.saveProblemButton.TabIndex = 2;
-      this.toolTip.SetToolTip(this.saveProblemButton, "Save Problem");
-      this.saveProblemButton.UseVisualStyleBackColor = true;
-      this.saveProblemButton.Click += new System.EventHandler(this.saveProblemButton_Click);
-      // 
       // newOperatorGraphButton
       // 
@@ -215,5 +176,4 @@
       this.tabControl.Controls.Add(this.operatorGraphTabPage);
       this.tabControl.Controls.Add(this.globalScopeTabPage);
-      this.tabControl.Controls.Add(this.problemTabPage);
       this.tabControl.Location = new System.Drawing.Point(0, 0);
       this.tabControl.Name = "tabControl";
@@ -258,30 +218,4 @@
       this.globalScopeTabPage.Text = "Global Scope";
       this.globalScopeTabPage.UseVisualStyleBackColor = true;
-      // 
-      // problemTabPage
-      // 
-      this.problemTabPage.Controls.Add(this.saveProblemButton);
-      this.problemTabPage.Controls.Add(this.openProblemButton);
-      this.problemTabPage.Controls.Add(this.newProblemButton);
-      this.problemTabPage.Controls.Add(this.problemViewHost);
-      this.problemTabPage.Location = new System.Drawing.Point(4, 22);
-      this.problemTabPage.Name = "problemTabPage";
-      this.problemTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.problemTabPage.Size = new System.Drawing.Size(794, 584);
-      this.problemTabPage.TabIndex = 2;
-      this.problemTabPage.Text = "Problem";
-      this.problemTabPage.UseVisualStyleBackColor = true;
-      // 
-      // problemViewHost
-      // 
-      this.problemViewHost.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.problemViewHost.Content = null;
-      this.problemViewHost.Location = new System.Drawing.Point(6, 36);
-      this.problemViewHost.Name = "problemViewHost";
-      this.problemViewHost.Size = new System.Drawing.Size(782, 542);
-      this.problemViewHost.TabIndex = 3;
-      this.problemViewHost.ViewType = null;
       // 
       // openFileDialog
@@ -315,5 +249,4 @@
       this.operatorGraphTabPage.ResumeLayout(false);
       this.globalScopeTabPage.ResumeLayout(false);
-      this.problemTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -332,9 +265,4 @@
     protected System.Windows.Forms.TabControl tabControl;
     protected System.Windows.Forms.TabPage globalScopeTabPage;
-    protected System.Windows.Forms.TabPage problemTabPage;
-    protected ViewHost problemViewHost;
-    protected System.Windows.Forms.Button newProblemButton;
-    protected System.Windows.Forms.Button saveProblemButton;
-    protected System.Windows.Forms.Button openProblemButton;
     protected System.Windows.Forms.OpenFileDialog openFileDialog;
     protected System.Windows.Forms.SaveFileDialog saveFileDialog;
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/EngineView.cs	(revision 2834)
@@ -62,5 +62,4 @@
     protected override void DeregisterContentEvents() {
       Content.OperatorGraphChanged -= new EventHandler(Content_OperatorGraphChanged);
-      Content.ProblemChanged -= new EventHandler(Content_ProblemChanged);
       Content.Prepared -= new EventHandler(Content_Prepared);
       Content.Started -= new EventHandler(Content_Started);
@@ -78,5 +77,4 @@
       base.RegisterContentEvents();
       Content.OperatorGraphChanged += new EventHandler(Content_OperatorGraphChanged);
-      Content.ProblemChanged += new EventHandler(Content_ProblemChanged);
       Content.Prepared += new EventHandler(Content_Prepared);
       Content.Started += new EventHandler(Content_Started);
@@ -97,6 +95,4 @@
         operatorGraphViewHost.Enabled = false;
         scopeView.Enabled = false;
-        newProblemButton.Enabled = openProblemButton.Enabled = saveProblemButton.Enabled = false;
-        problemViewHost.Enabled = false;
         startButton.Enabled = resetButton.Enabled = false;
         executionTimeTextBox.Enabled = false;
@@ -107,8 +103,4 @@
         scopeView.Content = Content.GlobalScope;
         scopeView.Enabled = true;
-        newProblemButton.Enabled = openProblemButton.Enabled = true;
-        saveProblemButton.Enabled = Content.Problem != null;
-        problemViewHost.Content = Content.Problem;
-        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         resetButton.Enabled = true;
@@ -124,12 +116,4 @@
       else
         operatorGraphViewHost.Content = Content.OperatorGraph;
-    }
-    protected void Content_ProblemChanged(object sender, EventArgs e) {
-      if (InvokeRequired)
-        Invoke(new EventHandler(Content_ProblemChanged), sender, e);
-      else {
-        saveProblemButton.Enabled = Content.Problem != null;
-        problemViewHost.Content = Content.Problem;
-      }
     }
     protected virtual void Content_Prepared(object sender, EventArgs e) {
@@ -140,7 +124,4 @@
         operatorGraphViewHost.Enabled = true;
         scopeView.Enabled = true;
-        newProblemButton.Enabled = openProblemButton.Enabled = true;
-        saveProblemButton.Enabled = Content.Problem != null;
-        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         stopButton.Enabled = false;
@@ -157,6 +138,4 @@
         operatorGraphViewHost.Enabled = false;
         scopeView.Enabled = false;
-        newProblemButton.Enabled = openProblemButton.Enabled = saveProblemButton.Enabled = false;
-        problemViewHost.Enabled = false;
         startButton.Enabled = false;
         stopButton.Enabled = true;
@@ -172,7 +151,4 @@
         operatorGraphViewHost.Enabled = true;
         scopeView.Enabled = true;
-        newProblemButton.Enabled = openProblemButton.Enabled = true;
-        saveProblemButton.Enabled = Content.Problem != null;
-        problemViewHost.Enabled = true;
         startButton.Enabled = !Content.Finished;
         stopButton.Enabled = false;
@@ -230,45 +206,4 @@
       }
     }
-    protected void newProblemButton_Click(object sender, EventArgs e) {
-      if (typeSelectorDialog == null) {
-        typeSelectorDialog = new TypeSelectorDialog();
-      }
-      typeSelectorDialog.Caption = "Select Problem";
-      typeSelectorDialog.TypeSelector.Configure(typeof(IProblem), false, false);
-
-      if (typeSelectorDialog.ShowDialog(this) == DialogResult.OK) {
-        Content.Problem = (IProblem)typeSelectorDialog.TypeSelector.CreateInstanceOfSelectedType();
-      }
-    }
-    protected void openProblemButton_Click(object sender, EventArgs e) {
-      openFileDialog.Title = "Open Problem";
-      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
-        IProblem problem = null;
-        try {
-          problem = XmlParser.Deserialize(openFileDialog.FileName) as IProblem;
-        }
-        catch (Exception ex) {
-          Auxiliary.ShowErrorMessageBox(ex);
-        }
-        if (problem == null)
-          MessageBox.Show(this, "Selected file does not contain a problem.", "Invalid File", MessageBoxButtons.OK, MessageBoxIcon.Error);
-        else
-          Content.Problem = problem;
-      }
-    }
-    protected void saveProblemButton_Click(object sender, EventArgs e) {
-      saveFileDialog.Title = "Save Problem";
-      if (saveFileDialog.ShowDialog(this) == DialogResult.OK) {
-        try {
-          if (saveFileDialog.FilterIndex == 1)
-            XmlGenerator.Serialize(Content.Problem, saveFileDialog.FileName, 0);
-          else
-            XmlGenerator.Serialize(Content.Problem, saveFileDialog.FileName, 9);
-        }
-        catch (Exception ex) {
-          Auxiliary.ShowErrorMessageBox(ex);
-        }
-      }
-    }
     protected virtual void startButton_Click(object sender, EventArgs e) {
       Content.Start();
Index: /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core.Views/3.3/HeuristicLab.Core.Views-3.3.csproj	(revision 2834)
@@ -131,10 +131,4 @@
       <DependentUpon>OperatorTreeView.cs</DependentUpon>
     </Compile>
-    <Compile Include="ProblemView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="ProblemView.Designer.cs">
-      <DependentUpon>ProblemView.cs</DependentUpon>
-    </Compile>
     <Compile Include="TypeSelectorDialog.cs">
       <SubType>Form</SubType>
Index: /trunk/sources/HeuristicLab.Core/3.3/Engine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/Engine.cs	(revision 2834)
@@ -71,21 +71,4 @@
 
     [Storable]
-    private IProblem problem;
-    /// <summary>
-    /// Gets or sets the current problem.
-    /// </summary>
-    public IProblem Problem {
-      get { return problem; }
-      set {
-        if (value == null) throw new ArgumentNullException();
-        if (value != problem) {
-          problem = value;
-          OnProblemChanged();
-          Prepare();
-        }
-      }
-    }
-
-    [Storable]
     private TimeSpan executionTime;
     /// <summary>
@@ -105,9 +88,9 @@
     /// </summary>
     [Storable]
-    private Stack<IExecutionSequence> executionStack;
+    private Stack<IOperation> executionStack;
     /// <summary>
     /// Gets the current execution stack.
     /// </summary>
-    protected Stack<IExecutionSequence> ExecutionStack {
+    protected Stack<IOperation> ExecutionStack {
       get { return executionStack; }
     }
@@ -146,6 +129,5 @@
     protected Engine() {
       globalScope = new Scope("Global");
-      problem = null;
-      executionStack = new Stack<IExecutionSequence>();
+      executionStack = new Stack<IOperation>();
       OperatorGraph = new OperatorGraph();
     }
@@ -162,9 +144,8 @@
       clone.OperatorGraph = (OperatorGraph)cloner.Clone(operatorGraph);
       clone.globalScope = (Scope)cloner.Clone(globalScope);
-      clone.problem = (IProblem)cloner.Clone(problem);
       clone.executionTime = executionTime;
-      IExecutionSequence[] contexts = executionStack.ToArray();
+      IOperation[] contexts = executionStack.ToArray();
       for (int i = contexts.Length - 1; i >= 0; i--)
-        clone.executionStack.Push((IExecutionSequence)cloner.Clone(contexts[i]));
+        clone.executionStack.Push((IOperation)cloner.Clone(contexts[i]));
       clone.running = running;
       clone.canceled = canceled;
@@ -172,4 +153,14 @@
     }
 
+    public void Prepare(IOperation initialOperation) {
+      canceled = false;
+      running = false;
+      globalScope.Clear();
+      ExecutionTime = new TimeSpan();
+      executionStack.Clear();
+      if (initialOperation != null)
+        executionStack.Push(initialOperation);
+      OnPrepared();
+    }
     /// <inheritdoc/>
     /// <remarks>Sets <c>myCanceled</c> and <c>myRunning</c> to <c>false</c>. The global scope is cleared,
@@ -178,12 +169,6 @@
     /// Calls <see cref="OnPrepared"/>.</remarks>
     public void Prepare() {
-      canceled = false;
-      running = false;
-      globalScope.Clear();
-      ExecutionTime = new TimeSpan();
-      executionStack.Clear();
-      if ((OperatorGraph.InitialOperator != null) && (Problem != null))
-        executionStack.Push(new ExecutionContext(null, OperatorGraph.InitialOperator, GlobalScope, Problem));
-      OnPrepared();
+      if (OperatorGraph.InitialOperator != null)
+        Prepare(new ExecutionContext(null, OperatorGraph.InitialOperator, GlobalScope));
     }
     /// <inheritdoc/>
@@ -254,15 +239,4 @@
     }
     /// <summary>
-    /// Occurs when the problem was changed.
-    /// </summary>
-    public event EventHandler ProblemChanged;
-    /// <summary>
-    /// Fires a new <c>ProblemChanged</c> event.
-    /// </summary>
-    protected virtual void OnProblemChanged() {
-      if (ProblemChanged != null)
-        ProblemChanged(this, EventArgs.Empty);
-    }
-    /// <summary>
     /// Occurs when the execution time changed.
     /// </summary>
Index: /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/ExecutionContext.cs	(revision 2834)
@@ -21,20 +21,24 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
+using HeuristicLab.Collections;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Core {
-  public class ExecutionContext : DeepCloneable, IExecutionSequence {
+  public class ExecutionContext : DeepCloneable, IExecutionContext, IAtomicOperation {
     [Storable]
-    private ExecutionContext parent;
-    public ExecutionContext Parent {
+    private IParameterizedItem parameterizedItem;
+
+    [Storable]
+    private IExecutionContext parent;
+    public IExecutionContext Parent {
       get { return parent; }
     }
 
-    [Storable]
-    private IOperator op;
+    public IObservableKeyedCollection<string, IParameter> Parameters {
+      get { return parameterizedItem.Parameters; }
+    }
+
     public IOperator Operator {
-      get { return op; }
+      get { return parameterizedItem as IOperator; }
     }
 
@@ -45,22 +49,14 @@
     }
 
-    [Storable]
-    private IProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-    }
-
     private ExecutionContext() {
       parent = null;
-      op = null;
+      parameterizedItem = null;
       scope = null;
-      problem = null;
     }
-    public ExecutionContext(ExecutionContext parent, IOperator op, IScope scope, IProblem problem) {
-      if ((op == null) || (scope == null) || (problem == null)) throw new ArgumentNullException();
+    public ExecutionContext(IExecutionContext parent, IParameterizedItem parameterizedItem, IScope scope) {
+      if ((parameterizedItem == null) || (scope == null)) throw new ArgumentNullException();
       this.parent = parent;
-      this.op = op;
+      this.parameterizedItem = parameterizedItem;
       this.scope = scope;
-      this.problem = problem;
     }
 
@@ -68,22 +64,21 @@
       ExecutionContext clone = new ExecutionContext();
       cloner.RegisterClonedObject(this, clone);
-      clone.parent = (ExecutionContext)cloner.Clone(parent);
-      clone.op = (IOperator)cloner.Clone(op);
+      clone.parent = (IExecutionContext)cloner.Clone(parent);
+      clone.parameterizedItem = (IParameterizedItem)cloner.Clone(parameterizedItem);
       clone.scope = (IScope)cloner.Clone(scope);
-      clone.problem = (IProblem)cloner.Clone(problem);
       return clone;
     }
 
-    public ExecutionContext CreateContext(IOperator op) {
-      return new ExecutionContext(parent, op, scope, problem);
+    public IAtomicOperation CreateOperation(IOperator op) {
+      return new ExecutionContext(parent, op, scope);
     }
-    public ExecutionContext CreateContext(IOperator op, IScope scope) {
-      return new ExecutionContext(parent, op, scope, problem);
+    public IAtomicOperation CreateOperation(IOperator op, IScope scope) {
+      return new ExecutionContext(parent, op, scope);
     }
-    public ExecutionContext CreateChildContext(IOperator op) {
-      return new ExecutionContext(this, op, scope, problem);
+    public IAtomicOperation CreateChildOperation(IOperator op) {
+      return new ExecutionContext(this, op, scope);
     }
-    public ExecutionContext CreateChildContext(IOperator op, IScope scope) {
-      return new ExecutionContext(this, op, scope, problem);
+    public IAtomicOperation CreateChildOperation(IOperator op, IScope scope) {
+      return new ExecutionContext(this, op, scope);
     }
   }
Index: /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/HeuristicLab.Core-3.3.csproj	(revision 2834)
@@ -104,7 +104,10 @@
     <Compile Include="ChangedEventArgs.cs" />
     <None Include="HeuristicLabCorePlugin.cs.frame" />
+    <Compile Include="Interfaces\IParameterizedItem.cs" />
+    <Compile Include="Interfaces\IAtomicOperation.cs" />
+    <Compile Include="Interfaces\IExecutionContext.cs" />
+    <Compile Include="Interfaces\IOperation.cs" />
+    <Compile Include="OperationCollection.cs" />
     <Compile Include="ValueParameterCollection.cs" />
-    <Compile Include="Interfaces\IProblem.cs" />
-    <Compile Include="Interfaces\IExecutionSequence.cs" />
     <Compile Include="Interfaces\IValueLookupParameter.cs" />
     <Compile Include="Interfaces\IValueParameter.cs" />
@@ -117,5 +120,4 @@
     <Compile Include="Item.cs" />
     <Compile Include="NamedItem.cs" />
-    <Compile Include="Problem.cs" />
     <Compile Include="OperatorGraph.cs" />
     <Compile Include="Interfaces\IParameter.cs" />
@@ -128,5 +130,4 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="ExecutionContextCollection.cs" />
     <Compile Include="ExecutionContext.cs" />
     <Compile Include="OperatorList.cs" />
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs	(revision 2834)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IAtomicOperation.cs	(revision 2834)
@@ -0,0 +1,30 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface which represents an atomic operation.
+  /// </summary>
+  public interface IAtomicOperation : IOperation {
+    IOperator Operator { get; }
+    IScope Scope { get; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IEngine.cs	(revision 2834)
@@ -38,8 +38,4 @@
     /// </summary>
     IScope GlobalScope { get; }
-    /// <summary>
-    /// Gets the problem of the current instance.
-    /// </summary>
-    IProblem Problem { get; set; }
 
     /// <summary>
@@ -62,4 +58,8 @@
     void Prepare();
     /// <summary>
+    /// Prepares the engine with a given initial operation.
+    /// </summary>
+    void Prepare(IOperation initialOperation);
+    /// <summary>
     /// Executes the whole run.
     /// </summary>
@@ -78,8 +78,4 @@
     /// </summary>
     event EventHandler OperatorGraphChanged;
-    /// <summary>
-    /// Occurs when the problem was changed.
-    /// </summary>
-    event EventHandler ProblemChanged;
     /// <summary>
     /// Occurs when the execution time was changed.
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs	(revision 2834)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IExecutionContext.cs	(revision 2834)
@@ -0,0 +1,38 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface which represents an execution context.
+  /// </summary>
+  public interface IExecutionContext : IDeepCloneable {
+    IExecutionContext Parent { get; }
+    IObservableKeyedCollection<string, IParameter> Parameters { get; }
+    IScope Scope { get; }
+
+    IAtomicOperation CreateOperation(IOperator op);
+    IAtomicOperation CreateOperation(IOperator op, IScope scope);
+    IAtomicOperation CreateChildOperation(IOperator op);
+    IAtomicOperation CreateChildOperation(IOperator op, IScope scope);
+  }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperation.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperation.cs	(revision 2834)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperation.cs	(revision 2834)
@@ -0,0 +1,27 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// Interface which represents an operation.
+  /// </summary>
+  public interface IOperation : IDeepCloneable { }
+}
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperator.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IOperator.cs	(revision 2834)
@@ -21,8 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
-using HeuristicLab.Common;
-using HeuristicLab.Collections;
 
 namespace HeuristicLab.Core {
@@ -31,7 +27,5 @@
   /// a basic instruction of an algorithm.
   /// </summary>
-  public interface IOperator : INamedItem {
-    IObservableKeyedCollection<string, IParameter> Parameters { get; }
-
+  public interface IOperator : INamedItem, IParameterizedItem {
     /// <summary>
     /// Gets or sets a boolean value whether the engine should stop here during the run.
@@ -44,5 +38,5 @@
     /// <param name="scope">The scope where to execute the current instance.</param>
     /// <returns>The next operation.</returns>
-    IExecutionSequence Execute(ExecutionContext context);
+    IOperation Execute(IExecutionContext context);
     /// <summary>
     /// Aborts the current operator.
Index: /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 2833)
+++ /trunk/sources/HeuristicLab.Core/3.3/Interfaces/IParameter.cs	(revision 2834)
@@ -21,8 +21,4 @@
 
 using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Core {
@@ -30,5 +26,5 @@
     Type DataType { get; }
     IItem ActualValue { get; set; }
-    ExecutionContext ExecutionContext { get; set; }
+    IExecutionContext ExecutionContext { get; set; }
   }
 }
